import { _decorator, CCFloat, Component, Node, tween, Tween, Vec3 } from 'cc';
const { ccclass, property } = _decorator;

export enum PropStatus {
    LIFE,
    DIE
}

@ccclass('PropComponent')
export class PropComponent extends Component {

    @property({ type: CCFloat })
    hp: number = 1;

    status: PropStatus = PropStatus.LIFE;

    speed: number = 50;

    start() {
        this.status = PropStatus.LIFE;
    }

    //受伤
    hurt(attack: number) {
        if (this.status == PropStatus.DIE) return;

        this.hp -= attack;
        console.log(`当前道具血量:${this.hp}`)
        if (this.hp <= 0) {
            this.hp = 0;
            this.status = PropStatus.DIE;
        }
    }

    //卷入龙卷风
    swallow() {
        Tween.stopAllByTarget(this.node);
        tween(this.node)
            .by(1, { position: new Vec3(0, this.node.position.y + 5, 0) })
            .call(() => {
                this.node.removeFromParent();
                this.node.destroy();
            })
            .start();
    }

    update(deltaTime: number) {

    }
}


